
//#define debug	1

#pragma sharedAllocation
#pragma update_PAGE 1 /* ON */

extern	page0 void lcd_data(void);

extern	char moji_1[16];
extern	unsigned int	moji100,moji10,moji1;
extern	unsigned long	ch_v;
extern	unsigned long	delta3, delta2, delta1;
extern	uns16	millisec;
void	delay_ms( void );
//const page0 char number2[]="0123456789";

#pragma bit FET3 @ PORTB.7		//FET3 drive port
#pragma bit FET2 @ PORTB.5		//FET2 drive port
#pragma bit FET1 @ PORTB.4		//FET1 drive port
#define	ON				0		// 0:photocapler LED=ON, Tr=ON, FET=ON
#define OFF				1		// 1:photocapler LED=OFF, Tr=OFF, FET=OFF

#pragma codepage 0
#pragma rambank 1


//----------------------------
extern	page0 unsigned int number( unsigned int mojimoji ){

unsigned int	c_code;

	c_code = mojimoji + 48;

	return(c_code);
}

//----------------------------
// get value from A/D.
// next step, convert numeric 9to0 , 100/10/1

extern	void get_moji(void){
unsigned long	tmp;

#if 0
	ad_ch = ADRESH;
	ch_v = ad_ch * 100;
	ch_v = ch_v / 51;			// 500 - 0
#endif
	
	moji100 = ch_v / 100;

	tmp     = moji100 * 100;
	moji10  = ch_v - tmp;
	moji10  = moji10 / 10;

	moji1   = ch_v - tmp;
	tmp     = moji10 * 10;	
	moji1   = moji1 - tmp;

}

//-----------------convert A/D data to numeral 500-0 ( 5.00V - 0.00V )
extern	void convert2volt(void){
unsigned long	ad_ch;

	ad_ch = ADRESH;
	ch_v = ad_ch * 100;
	ch_v = ch_v / 51;			// 500 - 0
}


//-----------------A/D convert ch5
extern	void ad5(void){

	CHS2 = 1;
	CHS1 = 0;
	CHS0 = 1;
	millisec = 1;
	delay_ms();		//must, acquisition time
	GO = 1;
#ifndef debug
	while(GO);	//ADϊ
#endif

}

		
//-----------------A/D convert ch4
extern	void ad4(void){

	CHS2 = 1;
	CHS1 = 0;
	CHS0 = 0;
	millisec = 1;
	delay_ms();		//must, acquisition time
	GO = 1;
#ifndef debug
	while(GO);	//ADϊ
#endif

}

//------------------A/D convert ch3
extern	void ad3(void){

	CHS2 = 0;
	CHS1 = 1;
	CHS0 = 1;
	millisec = 1;
	delay_ms();		//must, acquisition time
	GO = 1;
#ifndef debug
	while(GO);	//ADϊ
#endif

}


//-----------------------------------------
extern	void cell3_discharge( void )
{
unsigned long	dischargestart;
unsigned long	tmp;

	FET3 = ON;

//	do{
		ad5();
		convert2volt();
		dischargestart = ch_v;
		tmp = dischargestart - ch_v;

#if 0
		get_moji();
		moji_1[0]=number(moji100);
//		moji_1[1]='.';
		moji_1[2]=number(moji10);
		moji_1[3]=number(moji1);
//		lcd_data();
#endif

		millisec = 5000;
		delay_ms();
		delay_ms();
//}
//	while( tmp < delta3 );

	FET3 = OFF;
}


//-----------------------------------------
extern	void cell2_discharge( void )
{
unsigned long	dischargestart;
unsigned long	tmp;

	FET2 = ON;

//	do{
		ad4();
		convert2volt();
		dischargestart = ch_v;
		tmp = dischargestart - ch_v;

#if 0	// debug
		get_moji();
		moji_1[6]=number(moji100);
//		moji_1[7]='.';
		moji_1[8]=number(moji10);
		moji_1[9]=number(moji1);
		lcd_data();
#endif	// debug

		millisec = 5000;
		delay_ms();
		delay_ms();
//	}
//	while( tmp < delta2 );

	FET2 = OFF;
}


//-----------------------------------------
extern	void cell1_discharge( void )
{
unsigned long	dischargestart;
unsigned long	tmp;

	FET1 = ON;

//	do{
		ad3();
		convert2volt();
		dischargestart = ch_v;
		tmp = dischargestart - ch_v;

#if 0	// debug
		get_moji();
		moji_1[12]=number(moji100);
//		moji_1[13]='.';
		moji_1[14]=number(moji10);
		moji_1[15]=number(moji1);
//		lcd_data();
#endif	// debug

		millisec = 5000;
		delay_ms();
		delay_ms();
//	}
//	while( tmp < delta2 );

	FET1 = OFF;
}


//-----------------------------------------------
extern	void delay_ms( void )
// Delays a multiple of 1 milliseconds at 4 MHz
// using the TMR0 timer
{
    char next = 0;

#ifdef debug
	return;
#endif


//    OPTION = 2; // prescaler divide TMR0 rate by 8
	PS2=0;
	PS1=1;
	PS0=0;
	TMR0 = 2;  // deduct 2*8 fixed instruction cycles delay
    do  {
        next += 125;
//        clrwdt();  // needed only if watchdog is enabled
        while (TMR0 != next)   // 125 * 8 = 1000 (= 1 ms)
            ;
    } while ( -- millisec != 0);
}

